Subject: Re: bonding can't change to another slave if you ifdown the active slave

From: Nicolas de Pesloüan<[email-masked]>
Date: Sat, 05 Mar 2011 14:49:55 +0100

Le 05/03/2011 03:53, Andy Gospodarek a écrit :
> On Fri, Mar 04, 2011 at 10:15:17AM +0800, Weiping Pan wrote:
>> Hi,
>>
>> I'm doing some Linux bonding driver test, and I find a problem in
>> balance-rr mode.
>> That's it can't change to another slave if you ifdown the active slave.
>> Any comments are warmly welcomed!
>>
>> regards
>> Weiping Pan
>>
>> My host is Fedora 14, and I install VirtualBox (4.0.2), and enable 4
>> nics for the guest system.
>
> Does this mean you are passing 4 NICs from your host to your guest
> (maybe via direct pci-device assignment to the guest) or are you
> creating 4 virtual devices on the host that are in a bridge group on the
> host?

VirtualBox does not allow assignment of pci-device to the guest. The network interfaces on the guest 
are pure virtual one, with several modes available. In order to help you trouble shooting this 
problem, we need to know the mode form each of the virtual interfaces. Possible modes are NAT, 
bridged, internal-network, and host-only-network.

Please provide the output of the following command:

VBoxManage showvminfo <your-vm-uuid> | grep ^NIC

To display your vm uuid, use the following command:

VBoxManage list vms

>
> [...]
>> [root@localhost ~]# ifconfig eth7 down
>
> This is not a great way to test link failure with bonding.  The best way
> is to actually pull the cable so the interface is truly down.

To virtually plug or unplug the cable from a virtual interface, use the following command, replacing 
the # with the interface number (from 1 to 8):

VBoxManage controlvm setlinkstate# on
VBoxManage controlvm setlinkstate# off

	Nicolas.